#encoding:utf8
'''
file:testmodel.py
'''
# import cgitb
# cgitb.enable()
import sys

from PyQt5.QtCore import QUrl, QAbstractListModel,QModelIndex,pyqtSlot
from PyQt5 import QtQml
from PyQt5.QtGui import QGuiApplication
from PyQt5.QtQuick import QQuickView

class RuleModel(QAbstractListModel):
    def __init__(self,name=2,parent=None):
        super().__init__(parent)
        self._datas = [{"name":"name %s" % k} for k in range(name)]
    def setDS(self,ds):
        self._datas = ds
    def roleNames(self):
        return {300:"name".encode()}
    def data(self,index,role=500):
        return self._datas[index.row()][self.roleNames().get(role).decode()]
    def rowCount(self,parent=QModelIndex()):
        return len(self._datas)

class RuleGroupModel(QAbstractListModel):
    def __init__(self,parent=None):
        super().__init__(parent)
        self._datas = [{"name":"na1" ,"rulesModel":RuleModel(name=1)},
            {"name":"na2" ,"rulesModel":RuleModel(name=2)},
            {"name":"na3" ,"rulesModel":RuleModel(name=3)},
            {"name":"na4" ,"rulesModel":RuleModel(name=4)}
        ]
    def setDS(self,ds):
        self._datas = ds
    @pyqtSlot(str,result=int)
    def roleValue(self, roleName):
        if roleName == 'name':
            return 300
        elif roleName == 'rulesModel':
            return 500
        return -1
    def roleNames(self):
        return {300:"name".encode(),500:"rulesModel".encode()}
    def data(self,index,role=500):
        return self._datas[index.row()][self.roleNames().get(role).decode()]
    def rowCount(self,parent=QModelIndex()):
        return len(self._datas)
    
    
if __name__ == '__main__':

    
    app = QGuiApplication(sys.argv)

    view = QQuickView()
    
    engine = view.engine()
    engine.quit.connect(app.quit)
    
    modelA = RuleGroupModel()
    engine.rootContext().setContextProperty('ruleGroupsModel', modelA)


    view.setResizeMode(QQuickView.SizeRootObjectToView)
    QtQml.qmlRegisterType(RuleGroupModel, 'RuleGroupModel', 1, 0, 'RuleGroupModel')
    QtQml.qmlRegisterType(RuleModel, 'RuleModel', 1, 0, 'RuleModel')

    view.setSource(QUrl('Test.qml'))
    view.show()

    sys.exit(app.exec_())